import { JSX } from "../../../../utils/index.js";
const isLinkedReferenceType = (type) => type.visit({
    reference: (ref) => ref.reflection !== undefined,
}) ?? false;
function hasAnyLinkedReferenceType(h) {
    if (!h)
        return false;
    if (!h.isTarget && h.types.some(isLinkedReferenceType))
        return true;
    return hasAnyLinkedReferenceType(h.next);
}
export function hierarchy(context, props) {
    if (!props)
        return;
    const fullLink = hasAnyLinkedReferenceType(props) ? (JSX.createElement(JSX.Fragment, null,
        " ",
        "(",
        JSX.createElement("a", { href: context.relativeURL("hierarchy.html") + "#" + context.page.model.getFullName() }, context.i18n.theme_hierarchy_view_full()),
        ")")) : (JSX.createElement(JSX.Fragment, null));
    return (JSX.createElement("section", { class: "tsd-panel tsd-hierarchy" },
        JSX.createElement("h4", null,
            context.i18n.theme_hierarchy(),
            fullLink),
        hierarchyList(context, props)));
}
function hierarchyList(context, props) {
    return (JSX.createElement("ul", { class: "tsd-hierarchy" }, props.types.map((item, i, l) => (JSX.createElement("li", null,
        props.isTarget ? JSX.createElement("span", { class: "target" }, item.toString()) : context.type(item),
        i === l.length - 1 && !!props.next && hierarchyList(context, props.next))))));
}
